<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
	<NuxtLayout name="default">
		<div>

			<!-- sidebar navigation teleported to template -->
			<SidebarNav :nav="navItems" :title="'Catalog'" />

			<TopbarTopBar :breadcrumb="breadcrumb" />
			<div class="detail-header">
				<div class="row">
					<div class="col-xl-4">
						<div class="title">
							<h2>Customers</h2>
							<span class="type-quality">Quality Rules</span>
						</div>
					</div>
				</div>


			</div>
			<div class="detail-body">
				<div class="row">
					<div class="col-xl-3">
						<div class="about">
							<InfoBox title="Creation date" text="17:14:12 <br> 19 Nov 2024" />
							<InfoBox title="Last Edition" text="17:14:12 <br> 19 Nov 2024" />
						</div>
						<div class="info user">
							<h3>Owner</h3>
							<UserProfile />
						</div>
					</div>
					<div class="col-xl-8 offset-xl-1">
						<div class="about details">
							<InfoBox title="Domains" text="Healthcare Professionals, Analysts, Policy Makers, +12" />
							<InfoBox title="Applied to" text="241 Datasets" />
						</div>
						<div class="row">
							<div class="col-xl-9">
								<EditableTextBox title="Full description"
									text="Epidemiology: Epidemiology refers to the study of the distribution, patterns, and determinants of health and disease in populations. In the realm of datasets platforms, epidemiology datasets encompass a wide array of structured information related to diseases, their occurrence, spread, and associated factors." />
								<EditableTextBox title="Short description"
									text="Epidemiology: Epidemiology refers to the study of the distribution, patterns, and determinants of health." />
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="detail-tab">
				<QualityDetailTabs />
			</div>
			<div class="container">
				<div class="offset-xl-1 col-xl-10 mt-160">
					<BannersBannerCta :banners="BannerCta" />
				</div>
			</div>
		</div>
	</NuxtLayout>
</template>
<script setup lang="ts">
import type NavItemI from '~/interfaces/navItem';
import QualityDetailTabs from '../../components/tabs/QualityDetailTabs.vue';
import type sliderItemI from '~/interfaces/sliderItem';
import slide1 from '@/assets/images/slide1.png';
import { useRoute } from 'vue-router';

const route = useRoute();
const qualityRuleDetails = ref<any>(null);

const viewDefault = () => {
	console.log('show default home page');
}

const dummyClick = () => {
	console.log('dummyClick');
}

// Define Breadcrumb interface
interface BreadcrumbI {
    title: string;
    link: string;
}

const breadcrumb = ref<BreadcrumbI[]>([]);

const fetchData = async () => {
  if (route.params.id) {
    try {
	  const response = useFetchAuth(`/quality/customMetric/${route.params.id}`, {
            method: 'GET',
        }, useRuntimeConfig().public.API_DATAMITE_QUALITY_RULES);
      qualityRuleDetails.value = response || {};
      breadcrumb.value = [
        { title: 'Catalog', link: '/catalog' },
        { title: qualityRuleDetails.value?.name, link: '#' },
      ];
    } catch (error) {
      console.error('Error fetching data:', error);
      qualityRuleDetails.value = {}; // Reset on error
    }
  }
};
onMounted(async () => {
	await fetchData();
});

watch(() => route.params.id, async() => {
	await fetchData();
}, { immediate: true });

const navItems = ref<NavItemI[]>([
	{
		label: 'All',
		icon: 'list',
		action: viewDefault
	},
	{
		label: 'Combine Datasets',
		icon: 'chrome',
		action: dummyClick
	},
	{
		label: 'Recently Viewed',
		icon: 'clock',
		action: dummyClick
	},
	{
		label: 'Highlighted',
		icon: 'favourite',
		action: dummyClick
	},
	{
		label: 'Your Catalog',
		icon: 'loading',
		action: dummyClick
	}
]);

const BannerCta = ref<sliderItemI[]>([
	{
		id: 1,
		title: 'Have a question or doubts?',
		text: 'Check our FAQs and Documentation',
		button_text: 'Faqs and Documentation',
		button_link: 'https://www.google.com',
		media_type: 1,
		media_url: slide1,
		template: 1,
	}
])

console.log('inside', qualityRuleDetails);

</script>